Bug 1069547 (JON3-10, PRODMGT-544) - Support EAP 6.2/6.3 style patching
Summary: Support EAP 6.2/6.3 style patching
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: JON3-10, PRODMGT-544
Product: JBoss Operations Network
Classification: JBoss
Component: Core Server, UI, Provisioning, Plugin -- JDG, Plugin -- JBoss EAP 6, Plugin -- JPP, Plugin -- SOA 6
Version: JON 3.3.0
Hardware: Unspecified
OS: Unspecified
urgent
urgent
Target Milestone: ER05
: JON 3.3.0
Assignee: Lukas Krejci
QA Contact: Matt Mahoney
URL:
Whiteboard:
Depends On: 1133933 1135034 1135107 1136501 1136945 1136998 1138760 1138855 1139787 1140578 1141982 1142984 1145280 1160757
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-25 09:20 UTC by Heiko W. Rupp
Modified: 2018-12-06 15:56 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-12-11 14:02:23 UTC
Type: Feature Request


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
JBoss Issue Tracker JON3-10 Critical Verified Support EAP 6.2/6.3 style patching [PRODMGT-544] 2017-08-16 13:57:45 UTC
Red Hat Bugzilla 1050014 None None None Never
JBoss Issue Tracker PRODMGT-544 Major Closed JBoss ON needs to support patching managed resources based on EAP 6.2 2017-08-16 13:57:45 UTC

Internal Links: 1050014

Description Heiko W. Rupp 2014-02-25 09:20:21 UTC
It must be possible to patch EAP 6.2/6.3 kind of servers from JON.
This applies to EAP proper and also to layered products (if they support this patching scheme).

Comment 1 Heiko W. Rupp 2014-03-07 16:50:09 UTC
This also needs to support proxy access (with / without login) that can also be used by Bug 1070431. It also needs a proxy settings section on the admin page

Comment 2 Lukas Krejci 2014-04-01 09:20:52 UTC
What exactly does "support proxy access" mean? Downloading the patch from a remote location?

Comment 3 Lukas Krejci 2014-04-01 12:38:04 UTC
<pilhuhn> lkrejci "What exactly does "support proxy access" mean? Downloading the patch from a remote location?"
<pilhuhn> a) download patch from csp
<pilhuhn> b) possibly use a company wide proxy ("squid") that may require a username / password for access

Comment 6 Lukas Krejci 2014-07-30 15:21:32 UTC
commit cae809eea851205593fc6f8b8c696d1dbda6ba16
Merge: a106392 468df67
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Jul 30 15:51:33 2014 +0200

    Merged pull request #80 from metlos/bug/1069547
    
    BZ 1069547 / JON3-10  Support EAP 6.2/6.3 style patching

commit 582e53ed75959341227f0a68b3471a2fc122d9c2
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Jul 30 17:17:12 2014 +0200

    [BZ 1069547] Clearing API changes.

Comment 7 Jay Shaughnessy 2014-07-30 17:14:25 UTC
I hope I did this cherry-picking correctly...

release/jon3.3.x commit e82f83fa63faf403e59f5654cb0ab7e8eb1a2232
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Jul 30 17:17:12 2014 +0200

    [BZ 1069547] Clearing API changes.

release/jon3.3.x  commit 899a1925e489b13346b291e4d878af7a07595f8e
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Jul 30 15:51:33 2014 +0200

    Merged pull request #80 from metlos/bug/1069547

    BZ 1069547 / JON3-10  Support EAP 6.2/6.3 style patching

Comment 8 JBoss JIRA Server 2014-07-31 07:53:53 UTC
Heiko Rupp <hrupp@redhat.com> updated the status of jira JON3-10 to Resolved

Comment 9 Michael Burman 2014-08-15 14:05:54 UTC
Cherry-picked to release/jon3.3.x:

commit 74844b7c37954bf5b7b7c4b4780c48996725485d
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Jul 30 15:55:58 2014 +0200

    [BZ 1069547] Merged pull request #103, Limit the choice of resource groups and destinations

Comment 10 Mike Foley 2014-08-15 15:20:53 UTC
this jira needs a developer demo before being moved to ON_QA

there was much discussion about what was actually going to be supported here (content management workflows, bundles workflows, etc...)  i believe there was a possibility of 3 different workflows for applying patches.  pm had pushed back and may have narrowed this down ... not sure.

need a developer demo.  this is so QE can begin testcase development.

Comment 11 Mike Foley 2014-08-15 15:26:44 UTC
adding matt to this bz.  he is the qe owner.

Comment 12 Mike Foley 2014-08-15 15:28:55 UTC
QE Deliverable:

1) attend developer demo.  (clarify which workflows ...bundles, content-management ...are implemented and supported)
2) document the proposed testcases in tcms
3) have a testcase review meeting...with dev, qe, pm, and gss in attendance.  have the testcases reviewed and approved.
4) execute the approved testcases.  log bzs for every test that fails or cannot be executed.
5) document the testcase execution by providing a link to a tcms testcase execution run.

Comment 13 JBoss JIRA Server 2014-08-15 22:39:35 UTC
mfoley user <mfoley@redhat.com> updated the status of jira JON3-10 to Reopened

Comment 14 Simeon Pinder 2014-08-19 13:42:30 UTC
One more commit: 3f28c3da509f97 to release/jon3.3.x beyond Comment 9.

Comment 15 Simeon Pinder 2014-08-19 23:50:29 UTC
Moving to ON_QA as available to test in the following brew build:

https://brewweb.devel.redhat.com//buildinfo?buildID=379025

Comment 16 JBoss JIRA Server 2014-08-20 07:26:11 UTC
Heiko Rupp <hrupp@redhat.com> updated the status of jira JON3-10 to Resolved

Comment 18 JBoss JIRA Server 2014-08-21 16:25:28 UTC
mfoley user <mfoley@redhat.com> updated the status of jira JON3-10 to Reopened

Comment 28 Lukas Krejci 2014-08-28 13:57:53 UTC
Another commit not related to above test failure but discovered during testing of BZ 1134846.

commit 7cb3499a47ab3a46add5724cf0ebe9113b9f8ca3
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Thu Aug 28 15:46:54 2014 +0200

    [BZ 1069547] Throw UnknownRecipeException instead of overly broad Exception
    from the WildflyPatchBundleServerPluginComponent#parseRecipe().
    
    (cherry picked from commit fc231cc754aaf4aaa40545f96c3650920574e8e8)
    Signed-off-by: Lukas Krejci <lkrejci@redhat.com>

Comment 31 Lukas Krejci 2014-09-05 12:55:51 UTC
This aspect of the feature fell through the cracks somehow, my apologies.

master:
commit 2b9f3910341c36f89210a52f23dfec24aaf8894b
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Fri Sep 5 14:51:31 2014 +0200

    [BZ 1069547] Add support for patching host controller using bundle handover

release/jon3.3.x:
commit 189c36cb2bae327bea4486cb335094c53e1ebd1b
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Fri Sep 5 14:51:31 2014 +0200

    [BZ 1069547] Add support for patching host controller using bundle handover
    
    (cherry picked from commit 2b9f3910341c36f89210a52f23dfec24aaf8894b)

Comment 33 Simeon Pinder 2014-09-17 02:49:07 UTC
Moving to ON_QA as available for test with the following brew build:
https://brewweb.devel.redhat.com//buildinfo?buildID=385149

Comment 34 Lukas Krejci 2014-09-17 11:29:16 UTC
Reverting to POST. Some code has been committed (even to the release branch) but this is still not finished.

This is not yet ready for full QA.

Comment 35 Lukas Krejci 2014-09-22 17:01:02 UTC
Added a missing trait to standalone and host controllers to advertise the currently active patches:

master:
commit 5336d8c3380a8af3c8b9d73f4c2fc4da2c4e7a0a
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Mon Sep 22 18:55:29 2014 +0200

    [BZ 1069547] Adding "Active Patches" trait to Host ctl & Standalone svr
    
    As such, the user now has the overview of the patches applied to the
    individual Wfly/EAP servers in their env. This complements the bundle
    subsystem from which the same information could be deduced, too,
    under the assumption that RHQ server would be the sole "issuer" of
    the patches to the servers.

release/jon3.3.x:
commit 3bda1ba6fd6566ad46e1110910363e306267c817
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Mon Sep 22 18:55:29 2014 +0200

    [BZ 1069547] Adding "Active Patches" trait to Host ctl & Standalone svr
    
    As such, the user now has the overview of the patches applied to the
    individual Wfly/EAP servers in their env. This complements the bundle
    subsystem from which the same information could be deduced, too,
    under the assumption that RHQ server would be the sole "issuer" of
    the patches to the servers.
    
    (cherry picked from commit 5336d8c3380a8af3c8b9d73f4c2fc4da2c4e7a0a)

Comment 36 Lukas Krejci 2014-09-22 20:45:41 UTC
The release branch commit hash is this:
b6e69ef3f250613bc6f74f4d5e1867c3b4882feb

Comment 37 Lukas Krejci 2014-09-24 14:20:09 UTC
master: d1f320fad3c5155f1f9b374d6b928b8d7cab5927
release/jon3.3.x:
commit 068f1b28bbe95db9fd22d66ebd7ab43d9c934496
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Sep 24 16:11:40 2014 +0200

    [BZ 1069547] Fix AS7 plugin itests.
    
    The itests run with EAP 6.1.1 that does not support patching so I
    added an exception to the rule of non-null metrics in the itest.
    
    (cherry picked from commit d1f320fad3c5155f1f9b374d6b928b8d7cab5927)

Comment 38 Simeon Pinder 2014-09-29 08:12:35 UTC
Moving into ER05 as didn't make the ER04 cut.

Comment 43 Lukas Krejci 2014-10-07 20:46:37 UTC
Implementing last batch of changes agreed upon during the revert/purge discussions:

master: 5028a507c47f9d102159da9dbd260c11188fc0a7
release/jon3.3.x: ca40cae9c780371e849adbaf5085dffb0b6bf063
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Tue Oct 7 17:45:26 2014 +0200

    [BZ 1069547] Tweak revert and purge behavior to better handle group
    membership changes.
    
    The revert will fail if it doesn't find the patch id to rollback to in the
    history of patches applied through RHQ. This prevents rolling back
    unknown patches in situations where the actual history of applied patches
    differs from the one recorded by RHQ.
    
    During rollbacks, having nothing to rollback is no longer considered an
    error and is merely reported through an audit message. This helps in
    keeping reverts and purges successful in the histories even when things
    didn't go as "smoothly" as they could (but don't end up in an actual
    error).
    
    Partial success of rollback is now reported as an error only if
    some of the to-be-rolled-back patches are still applied yet the state
    of patch history prevents them from being rolled back in expected order
    (this means that some other patches were applied on top of or in between of
    the expected history).
    Otherwise a mere warning is issued to the deployment audit that those
    patches were to be rolled back but were not found installed anymore.
    
    (cherry picked from commit 5028a507c47f9d102159da9dbd260c11188fc0a7)

master: 9782280301f7c83ff1aa39123697bc63216071e8
release/jon3.3.x: 48521897d6cb6268caef6b80bf052842f49be3f2
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Mon Sep 29 23:55:27 2014 +0200

    [BZ 1069547] Only allow single destination to apply patches to server
    
    This makes it possible to avoid overwriting of each other's work by
    multiple destinations targetting an overlapping set of resources.
    
    (cherry picked from commit 9782280301f7c83ff1aa39123697bc63216071e8)

Comment 44 Lukas Krejci 2014-10-07 20:58:07 UTC
master: 5c0b2964cb53dad0398286d984141a439f7ae028
release/jon3.3.x: 740e5d96427bdef83f1d4d3d6736ad8e1c2dec01
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Tue Oct 7 22:54:42 2014 +0200

    [BZ 1069547] Patches no longer deployable through bundle handover.
    
    (cherry picked from commit 5c0b2964cb53dad0398286d984141a439f7ae028)

Comment 46 Simeon Pinder 2014-10-21 20:24:10 UTC
Moving to ON_QA as available to test with the latest brew build:
https://brewweb.devel.redhat.com//buildinfo?buildID=394734

Comment 47 JBoss JIRA Server 2014-10-23 02:08:37 UTC
mfoley user <mfoley@redhat.com> updated the status of jira JON3-10 to Resolved


Note You need to log in before you can comment on or make changes to this bug.